//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "win_remote.h"
#include "win_main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
Tfrm_remote *frm_remote;
//---------------------------------------------------------------------------
__fastcall Tfrm_remote::Tfrm_remote(TComponent* Owner)
	: TForm(Owner)
{
	this->alphaValue = 255;
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_remote::l_closeClick(TObject *Sender)
{
	exit(0);
}
//---------------------------------------------------------------------------


void __fastcall Tfrm_remote::l_closeMouseLeave(TObject *Sender)
{
	l_close->Font->Color = RGB(0,0,0);
	l_callIDE->Hide();
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_remote::l_closeMouseEnter(TObject *Sender)
{
	l_close->Font->Color = RGB(255,0,0);
	l_callIDE->Show();
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_remote::img_titleMouseEnter(TObject *Sender)
{
	l_callIDE->Show();
	l_up->Hide();
	l_down->Hide();
	
	//AlphaBlendValue = 255;
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_remote::img_titleMouseLeave(TObject *Sender)
{
	l_callIDE->Hide();
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_remote::l_upMouseEnter(TObject *Sender)
{
	l_callIDE->Show();
	l_up->Show();
	l_down->Show();
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_remote::l_downMouseEnter(TObject *Sender)
{
	l_callIDE->Show();
	l_up->Show();
	l_down->Show();
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_remote::l_callIDEClick(TObject *Sender)
{
	//call IDE
	this->Hide();
	frm_main->setEditingWindow();

	frm_main->ShowModal();
}
//---------------------------------------------------------------------------



void __fastcall Tfrm_remote::l_callIDEMouseLeave(TObject *Sender)
{
	l_callIDE->Font->Color = RGB(0,0,0);
	this->AlphaBlendValue = alphaValue;
}
//---------------------------------------------------------------------------


void __fastcall Tfrm_remote::l_callIDEMouseEnter(TObject *Sender)
{
	l_callIDE->Font->Color = RGB(80,80,125);
	l_callIDE->Show();
}
//---------------------------------------------------------------------------


void __fastcall Tfrm_remote::img_foMouseEnter(TObject *Sender)
{
	l_callIDE->Show();
	l_up->Show();
	l_down->Show();
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_remote::img_foMouseLeave(TObject *Sender)
{
	l_up->Hide();
	l_down->Hide();
}
//---------------------------------------------------------------------------




void __fastcall Tfrm_remote::l_downClick(TObject *Sender)
{
	alphaValue -= 40;
	if(alphaValue < 25)
		alphaValue = 25;

	this->AlphaBlendValue = alphaValue;
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_remote::l_upClick(TObject *Sender)
{
	alphaValue += 40;
	if(alphaValue > 255)
		alphaValue = 255;

	this->AlphaBlendValue = alphaValue;

}
//---------------------------------------------------------------------------


void __fastcall Tfrm_remote::img_titleMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	ReleaseCapture();
	SendMessage(this->Handle, WM_NCLBUTTONDOWN, HTCAPTION, 0);
}
//---------------------------------------------------------------------------


void __fastcall Tfrm_remote::FormShow(TObject *Sender)
{
    SetForegroundWindow(this->Handle);
	SetWindowPos(this->Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE);
}
//---------------------------------------------------------------------------




void __fastcall Tfrm_remote::img_foMouseDown(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{
	ReleaseCapture();
	SendMessage(this->Handle, WM_NCLBUTTONDOWN, HTCAPTION, 0);
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_remote::CreateParams(TCreateParams &Params)
{
	TForm::CreateParams(Params);
	Params.Style = WS_POPUP;
}


void __fastcall Tfrm_remote::BitBtn1Click(TObject *Sender)
{
	//SetWindowLongA(this->Handle, GWL_STYLE, WS_POPUPWINDOW);
//	::SetParent(this->Handle, frm_main->Handle);
}
//---------------------------------------------------------------------------


