#include <stdio.h>
#include <windows.h>
#include "loadModule.h"
#include "type.h"


HWND (WINAPI *orgCreateWindowExA)(DWORD,LPCSTR,LPCSTR,DWORD,int,int,int,int,HWND,HMENU,HINSTANCE,LPVOID) = NULL;
HWND (WINAPI *orgCreateWindowExW)(DWORD,LPCWSTR,LPCWSTR,DWORD,int,int,int,int,HWND,HMENU,HINSTANCE,LPVOID) = NULL;



HWND processingCreateWindow(DWORD &dwExStyle, void*, void*, DWORD &dwStyle, 
	int &X, int &Y, int &nWidth, int &nHeightm, HWND &hWndParent, HMENU &hMenu, HINSTANCE &hInstance, LPVOID &lpParam){
	char buf[MAX_STRING_LENGTH];
	
	GetClassNameA(hWndParent, buf, MAX_STRING_LENGTH);

	if(buf[0] == NULL)
	{
		return FAIL;
	}

	loadModule::getLoadModule();

	
	return OK;
}



HWND WINAPI NewCreateWindowExA(DWORD dwExStyle, LPCSTR lpClassName, LPCSTR lpWindowName, DWORD dwStyle,
    int X, int Y, int nWidth, int nHeight, HWND hWndParent, HMENU hMenu, HINSTANCE hInstance, LPVOID lpParam){
	
	processingCreateWindow(dwExStyle, (void*)lpClassName, (void*)lpWindowName, dwStyle, X, Y, nWidth, nHeight, hWndParent, hMenu, hInstance, lpParam);

	return orgCreateWindowExA(dwExStyle, lpClassName, lpWindowName, dwStyle, X, Y, nWidth, nHeight, hWndParent, hMenu, hInstance, lpParam);;
}


HWND WINAPI NewCreateWindowExW(DWORD dwExStyle, LPCWSTR lpClassName, LPCWSTR lpWindowName, DWORD dwStyle,
    int X, int Y, int nWidth, int nHeight, HWND hWndParent, HMENU hMenu, HINSTANCE hInstance, LPVOID lpParam){
	
	processingCreateWindow(dwExStyle, (void*)lpClassName, (void*)lpWindowName, dwStyle, X, Y, nWidth, nHeight, hWndParent, hMenu, hInstance, lpParam);

	return orgCreateWindowExW(dwExStyle, lpClassName, lpWindowName, dwStyle, X, Y, nWidth, nHeight, hWndParent, hMenu, hInstance, lpParam);;
}

int SetHook(HANDLE hProc){
	//BOOL (WINAPI *NewTextOut)(HDC,int,int,LPCTSTR,int) = NULL;
	
	if (hProc != (HANDLE)-1){

		PIMAGE_DOS_HEADER hbase = (PIMAGE_DOS_HEADER)hProc;
		PIMAGE_NT_HEADERS hnt = (PIMAGE_NT_HEADERS)((DWORD)hbase->e_lfanew + (DWORD)hbase);

		PIMAGE_IMPORT_DESCRIPTOR hdes = (PIMAGE_IMPORT_DESCRIPTOR)((DWORD)hbase + 
					(DWORD)hnt->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress);
		
		
		while (hdes->Name){
			if (NULL == stricmp((char*)((DWORD)hProc + (DWORD)hdes->Name),"USER32.dll")){

				PIMAGE_THUNK_DATA funfirst = (PIMAGE_THUNK_DATA)((DWORD)hProc + (DWORD)hdes->FirstThunk);
				PIMAGE_THUNK_DATA funorg = (PIMAGE_THUNK_DATA)((DWORD)hProc + (DWORD)hdes->OriginalFirstThunk);
				
				while(funfirst->u1.Function != NULL){

					PIMAGE_IMPORT_BY_NAME pByName = (PIMAGE_IMPORT_BY_NAME)
												((DWORD)hProc + (DWORD)funorg->u1.AddressOfData);
					
					//MessageBox(NULL, (char*)pByName->Name, "???", MB_OK);
					if (((DWORD)funfirst->u1.Function == (DWORD)GetProcAddress(LoadLibrary("USER32.dll"),TEXT("CreateWindowExA"))) ||
							(stricmp((char*)pByName->Name,"CreateWindowExA") == 0)  ){
						

						MEMORY_BASIC_INFORMATION mbi;
						VirtualQuery(funfirst, &mbi, sizeof(mbi));
						
						if(!VirtualProtect(mbi.BaseAddress, mbi.RegionSize, PAGE_READWRITE, &mbi.Protect)){
							MessageBox(NULL, MESSAGE_FAIL_FAIL_WRITE_TO_MEMORY, CAPTION_ERROR_EXIT, MB_OK);
							return NULL;
						}
						
						orgCreateWindowExA = (HWND (WINAPI *)(DWORD,LPCSTR,LPCSTR,DWORD,int,int,int,int,HWND,HMENU,HINSTANCE,LPVOID))funfirst->u1.Function;
						funfirst->u1.Function = (DWORD)NewCreateWindowExA;
						
						DWORD dwTmp;
						VirtualProtect(mbi.BaseAddress, mbi.RegionSize, mbi.Protect, &dwTmp);
						MessageBox(NULL, "Hook ", "??", MB_OK);
						//return 0;
					}else if (((DWORD)funfirst->u1.Function == (DWORD)GetProcAddress(LoadLibrary("USER32.dll"),TEXT("CreateWindowExW"))) ||
							(stricmp((char*)pByName->Name,"CreateWindowExW") == 0)  ){
						MEMORY_BASIC_INFORMATION mbi;
						VirtualQuery(funfirst, &mbi, sizeof(mbi));
						
						if(!VirtualProtect(mbi.BaseAddress, mbi.RegionSize, PAGE_READWRITE, &mbi.Protect)){
							MessageBox(NULL, MESSAGE_FAIL_FAIL_WRITE_TO_MEMORY, CAPTION_ERROR_EXIT, MB_OK);
							return NULL;
						}
						
						orgCreateWindowExW = (HWND (WINAPI *)(DWORD,LPCWSTR,LPCWSTR,DWORD,int,int,int,int,HWND,HMENU,HINSTANCE,LPVOID))funfirst->u1.Function;
						funfirst->u1.Function = (DWORD)NewCreateWindowExW;
						
						DWORD dwTmp;
						VirtualProtect(mbi.BaseAddress, mbi.RegionSize, mbi.Protect, &dwTmp);
						MessageBox(NULL, "Hook www", "??", MB_OK);
						//return 0;
					}
					
					
					funfirst++;
					funorg++;
				}
			}

			hdes++;
		}
	}

	return 0;
}
