#include "Item.h"

void Item::addevent(DWORD type, string code){
	this->m_events[type] = code;

	return;
}

void Item::addAttribute(string name, string value){
	this->m_attributes[name] = value;

	return;
}



bool Item::getAttribute(string name, string &value){
	if(m_attributes.find(name) != m_attributes.end()){
		value = m_attributes[name];
		return true;
	}
	
	return false;
}

bool Item::getEvent(DWORD type, string &code){	
	if(m_events.find(type) != m_events.end()){
		code = m_events[type];
		return true;
	}

	return false;
}

void Item::setType(DWORD type){
	this->m_type = type;
}

DWORD Item::getType(){
	return this->m_type;
}