#include <stdio.h>
#include <windows.h>

#include "APIHook.h"

#include "loadModule.h"

#include "type.h"
#include "_ASSERT.h"


BOOL APIENTRY DllMain( HMODULE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved){
	
	switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		{
			MessageBox(NULL, "", "??", MB_OK);
			
			loadModule* loadmodule = loadModule::getLoadModule();
			
			char buf[MAX_STRING_LENGTH] = {0,};
			GetModuleFileName(NULL, buf, MAX_STRING_LENGTH);

			if(buf[0] == NULL){
				ASSERT(false);//̸ ùٸ ʽϴ.
				return FALSE;
			}

			string path = buf;

			string::size_type pos = path.find_last_of("\\");
			if(pos == string::npos){
				ASSERT(false);//̸ ùٸ ʽϴ.
				return FAIL;
			}
			
			string str_path = path.substr(pos + 1);

			GetTempPathA(MAX_STRING_LENGTH, buf);
			
			sprintf(buf, "%s%s.xml", buf, str_path.c_str());

			loadmodule->parsing(buf);

			SetHook(GetModuleHandleA(NULL));
			//loadmodule->parsing("D:\\Documents and Settings\\root\\ ȭ\\path.xml");
		}
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
	}

	return TRUE;
}