//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "win_remote.h"
#include "win_main.h"
#include "win_rc.h"
#include "global.h"
#include "win_code.h"

#include <iostream>
#include <string>

using namespace std;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
Tfrm_main *frm_main;
//LRESULT (CALLBACK *ff)(HWND, UINT, WPARAM , LPARAM );
WNDPROC ff;
int apply(String name, String key, String value);

int DeleteControl(HWND hwnd);
int CALLBACK fun_enumchildwin_windowFormPoint(HWND hwnd, HWND *result);
HWND windowFormPoint(HWND hwnd);
int IDE_regWindow(HWND);
int IsCanUseValuename(char* name);
LRESULT CALLBACK HookProc(int code, WPARAM wParam, LPARAM lParam);

int lua_getvalue(lua_State *g_pLuaSt){

	int n = lua_gettop(g_pLuaSt);

	if(n < 1){
		lua_pushnumber(g_pLuaSt, 0);   // push 0
		return 1;
	}

	DWORD* addr = (DWORD *)(atoi(lua_tostring(g_pLuaSt, 1)));

	lua_pushnumber(g_pLuaSt, *addr);
	return 1;
}

int lua_setvalue(lua_State *g_pLuaSt){

	int n = lua_gettop(g_pLuaSt);

	if(n < 1){
		lua_pushnumber(g_pLuaSt, 0);   // push 0
		return 1;
	}

	DWORD* addr = (DWORD *)(atoi(lua_tostring(g_pLuaSt, 1)));
	*addr = (DWORD)(atoi(lua_tostring(g_pLuaSt, 2)));

	return 0;
}
int lua_output(lua_State *g_pLuaSt){
	int n = lua_gettop(g_pLuaSt);

	if(n < 1){
		lua_pushnumber(g_pLuaSt, 0);   // push 0
		return 1;
	}

	OutputDebugStringA(lua_tostring(g_pLuaSt, 1));

	return 0;
}
int lua_getatt(lua_State *g_pLuaSt){
	int n = lua_gettop(g_pLuaSt);

	if(n < 2){
		lua_pushnumber(g_pLuaSt, 0);   // push 0
		return 1;
	}

	char name[256];
	char att[256];

	memset(name, 0, sizeof(name));
	memset(att, 0, sizeof(name));

	strcpy(name, lua_tostring(g_pLuaSt, 1));
	strcpy(att, lua_tostring(g_pLuaSt, 2));

	HWND h = frm_main->map_nameToHandle[name];

	MAP_ATT &m = *(MAP_ATT*)frm_main->map_obj[h];

	lua_pushstring(g_pLuaSt, m[att].c_str());

	return 1;
}

int lua_getcheck(lua_State *g_pLuaSt){
	int n = lua_gettop(g_pLuaSt);

	if(n < 1){
		lua_pushnumber(g_pLuaSt, 0);   // push 0
		return 1;
	}

	char name[256];

	memset(name, 0, sizeof(name));

	strcpy(name, lua_tostring(g_pLuaSt, 1));

	HWND h = frm_main->map_nameToHandle[name];

	if(SendMessageA(h, BM_GETCHECK, 0, 0)){
		lua_pushnumber(g_pLuaSt, 1);   // push 1
	}else{
		lua_pushnumber(g_pLuaSt, 0);   // push 1
	}

	return 1;
}

int lua_sendmessage(lua_State *g_pLuaSt){
	int n = lua_gettop(g_pLuaSt);

	if(n < 5){
		lua_pushnumber(g_pLuaSt, 0);   // push 0
		return 1;
	}

	HWND hwnd = (HWND)atoi(lua_tostring(g_pLuaSt, 1));
	DWORD msg = (DWORD)atoi(lua_tostring(g_pLuaSt, 2));
	int type = (int)atoi(lua_tostring(g_pLuaSt, 3));

	if(type == 0){
		int w = (int)atoi(lua_tostring(g_pLuaSt, 4));
		int l = (int)atoi(lua_tostring(g_pLuaSt, 5));
		int result = SendMessageA(hwnd, msg, (WPARAM)w, (LPARAM)l);
		lua_pushnumber(g_pLuaSt, result);
		return 1;
	}else if(type == 1){
		int w = (int)atoi(lua_tostring(g_pLuaSt, 4));
		int result = SendMessageA(hwnd, msg, (WPARAM)w, (LPARAM)lua_tostring(g_pLuaSt, 5));
		lua_pushnumber(g_pLuaSt, result);
		return 1;
	}else if(type == 2){
		int w = (int)atoi(lua_tostring(g_pLuaSt, 4));
		DWORD temp = 0;
		SendMessageA(hwnd, msg, (WPARAM)w, (LPARAM)&temp);
		lua_pushnumber(g_pLuaSt, temp);
		return 1;
	}else if(type == 3){
		DWORD temp1 = 0;
		DWORD temp2 = 0;
		SendMessageA(hwnd, msg, (WPARAM)&temp1, (LPARAM)&temp2);
		lua_pushnumber(g_pLuaSt, temp1);
		lua_pushnumber(g_pLuaSt, temp1);
		return 2;
	}

	return 0;
}



int lua_getsel(lua_State *g_pLuaSt){
	int n = lua_gettop(g_pLuaSt);

	if(n < 1){
		lua_pushnumber(g_pLuaSt, 0);   // push 0
		return 1;
	}

	char name[256];

	memset(name, 0, sizeof(name));

	strcpy(name, lua_tostring(g_pLuaSt, 1));

	HWND h = frm_main->map_nameToHandle[name];
	int s = 0;
	int e = 0;

	SendMessageA(h, EM_GETSEL, (WPARAM)&s, (LPARAM)&e);

	lua_pushnumber(g_pLuaSt, s);   // push 1
	lua_pushnumber(g_pLuaSt, e);   // push 1

	return 2;
}


int lua_setsel(lua_State *g_pLuaSt){
	int n = lua_gettop(g_pLuaSt);

	if(n < 3){
		lua_pushnumber(g_pLuaSt, 0);   // push 0
		return 1;
	}

	char name[256];
	char nums[256];
	char nume[256];

	memset(name, 0, sizeof(name));
	memset(nums, 0, sizeof(nums));
	memset(nume, 0, sizeof(nume));

	strcpy(name, lua_tostring(g_pLuaSt, 1));
	strcpy(nums, lua_tostring(g_pLuaSt, 2));
	strcpy(nume, lua_tostring(g_pLuaSt, 3));

	HWND h = frm_main->map_nameToHandle[name];
	SendMessageA(h, EM_SETSEL, atoi(nums), (LPARAM)atoi(nume));

	lua_pushnumber(g_pLuaSt, 1);   // push 1

	return 1;
}

int lua_seltext(lua_State *g_pLuaSt){
	MessageBeep(1000);
	int n = lua_gettop(g_pLuaSt);

	if(n < 2){
		lua_pushnumber(g_pLuaSt, 0);   // push 0
		return 1;
	}

	char name[256];
	char msg[256];

	memset(name, 0, sizeof(name));
	memset(msg, 0, sizeof(msg));

	strcpy(name, lua_tostring(g_pLuaSt, 1));
	strcpy(msg, lua_tostring(g_pLuaSt, 2));

	HWND h = frm_main->map_nameToHandle[name];
	SendMessageA(h, EM_REPLACESEL, FALSE, (LPARAM)msg);

	lua_pushnumber(g_pLuaSt, 1);   // push 1

	return 1;
}


int lua_msgbox(lua_State *g_pLuaSt){
	int n = lua_gettop(g_pLuaSt);

	if(n < 2){
		lua_pushnumber(g_pLuaSt, 0);   // push 0
		return 1;
	}

	char szMessage[256];
	char szCaption[256];

	memset(szMessage, 0, sizeof(szMessage));
	memset(szCaption, 0, sizeof(szCaption));

	strcpy(szMessage, lua_tostring(g_pLuaSt, 1));
	strcpy(szCaption, lua_tostring(g_pLuaSt, 2));
	MessageBox(frm_main->Handle , szMessage, szCaption, MB_OK);

	lua_pushnumber(g_pLuaSt, 1);   // push 1

	return 1;
}


int lua_setfocus(lua_State *g_pLuaSt){
	int n = lua_gettop(g_pLuaSt);

	if(n < 1){
		lua_pushnumber(g_pLuaSt, 0);   // push 0
		return 1;
	}

	char msg[256];

	memset(msg, 0, sizeof(msg));
	strcpy(msg, lua_tostring(g_pLuaSt, 1));
	lua_pushnumber(g_pLuaSt, 1);   // push 1

	SetFocus(frm_main->map_nameToHandle[msg]);
	return 1;
}

int lua_exit(lua_State *g_pLuaSt){
	exit(0);
	return 0;
}

int lua_sendkey(lua_State *g_pLuaSt){
	int n = lua_gettop(g_pLuaSt);

	if(n < 1){
		lua_pushnumber(g_pLuaSt, 0);   // push 0
		return 1;
	}

	char msg[256];

	memset(msg, 0, sizeof(msg));
	strcpy(msg, lua_tostring(g_pLuaSt, 1));
	lua_pushnumber(g_pLuaSt, 1);   // push 1
	int i = 0;
	//MessageBeep(1000);
	//MessageBox(NULL, msg, "Ff",MB_OK);

	while(msg[i] != NULL){
	//MessageBeep(1000);
		if(IsCharAlphaA(msg[i]) == TRUE){
			if(IsCharLowerA(msg[i]) == TRUE){
				msg[i] -= 'a' - 'A';
				keybd_event( (BYTE)msg[i], MapVirtualKeyA((BYTE)msg[i], 0), 0, 0 );
				Sleep(10);
				keybd_event( (BYTE)msg[i], MapVirtualKeyA((BYTE)msg[i], 0), KEYEVENTF_KEYUP, 0 );
				Sleep(10);
			}else{
				keybd_event( (BYTE)VK_RSHIFT, MapVirtualKeyA((BYTE)VK_RSHIFT, 0), 0, 0 );
				Sleep(10);
				keybd_event( (BYTE)msg[i], MapVirtualKeyA((BYTE)msg[i], 0), 0, 0 );
				Sleep(10);
				keybd_event( (BYTE)msg[i], MapVirtualKeyA((BYTE)msg[i], 0), KEYEVENTF_KEYUP, 0 );
				Sleep(10);
				keybd_event( (BYTE)VK_RSHIFT, MapVirtualKeyA((BYTE)VK_RSHIFT, 0), KEYEVENTF_KEYUP, 0 );
				Sleep(10);
			}
		}else{
			keybd_event( (BYTE)msg[i], MapVirtualKeyA((BYTE)msg[i], 0), 0, 0 );
			Sleep(10);
			keybd_event( (BYTE)msg[i], MapVirtualKeyA((BYTE)msg[i], 0), KEYEVENTF_KEYUP, 0 );
			Sleep(10);
		}
		i++;
	}
	return 1;
}

int lua_controlMessage(lua_State *g_pLuaSt){

	int n = lua_gettop(g_pLuaSt);

	if(n < 2){
		lua_pushnumber(g_pLuaSt, 0);   // push 0
		return 1;
	}

	char name[256];
	char att[256];
	char value[256];

	memset(name, 0, sizeof(name));
	memset(att, 0, sizeof(att));
	memset(value, 0, sizeof(value));

	strcpy(name, lua_tostring(g_pLuaSt, 1));
	strcpy(att, lua_tostring(g_pLuaSt, 2));
	strcpy(value, lua_tostring(g_pLuaSt, 3));

	//frm_main->map_nameToHandle[msg]
	apply(name, att, value);

	lua_pushnumber(g_pLuaSt, 1);   // push 1

	return 0;
}


int ScreenToClientRect(HWND hwnd, RECT &rect){

	POINT tp;

	tp.x = rect.left;
	tp.y = rect.top;
	::ScreenToClient(hwnd , &tp);

	rect.left = tp.x;
	rect.top = tp.y;

	tp.x = rect.right;
	tp.y = rect.bottom;

	::ScreenToClient(hwnd , &tp);
	rect.right = tp.x;
	rect.bottom = tp.y;

	return 0;
}


LRESULT CALLBACK fun_HookProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){
	if(msg == WM_CREATE){
		//SetCursor(LoadCursor(NULL,IDC_ARROW));
	}
	/*
	switch(msg){
		case WM_PAINT:
		case WM_SETREDRAW:
		case WM_SYNCPAINT:
		case WM_NCPAINT:
		case WM_CTLCOLOREDIT:
		case WM_ERASEBKGND:
		case WM_NCHITTEST:
			return CallWindowProc((int(__stdcall *)())frm_main->map_funaddr[hWnd], hWnd, msg, wParam, lParam);
	}

	if(msg == WM_SIZE){
		return DefWindowProcA(hWnd, msg, wParam, lParam);
	}
	*/
	if(global::state_run == TRUE){
		if(frm_main->map_hwndToEvent.find(hWnd) != frm_main->map_hwndToEvent.end()){//ڵ 
			MAP_EVENT &t = *(MAP_EVENT*)frm_main->map_hwndToEvent[hWnd];

			if(t.find(msg) != t.end()){//޽ 
				lua_getglobal(global::g, t[msg].c_str());
				lua_pushnumber(global::g, (int)wParam);
				lua_pushnumber(global::g, (int)lParam);

				lua_call(global::g, 2, 1);
				int result = (int)lua_tonumber(global::g, -1);
				lua_pop(global::g, 1);

				if(result == 0){
					return CallWindowProc((int(__stdcall *)())frm_main->map_funaddr[hWnd], hWnd, msg, wParam, lParam);
				}else if(result == 1){
					return TRUE;
				}else if(result == 2){
					return DefWindowProcA(hWnd, msg, wParam, lParam);
				}
			}

		}
	}
	static bool lbutton = false;
	static POINT backPos = {0,};
	static bool lcreate = false;

	HWND hwnd_topWin = (HWND)frm_main->page_win->ActivePage->Tag;

	HWND phwnd = GetParent(hWnd);
	while(GetParent(phwnd) != NULL){
		phwnd = GetParent(phwnd);
	}

	if(phwnd == NULL){
		phwnd = hWnd;
	}

	if(find(frm_main->m_wins.begin(),frm_main->m_wins.end(), phwnd) == frm_main->m_wins.end()){

		if(msg == WM_NCLBUTTONDOWN){
		}else if(msg == WM_NCLBUTTONUP){
		}else if(msg == WM_NCLBUTTONDBLCLK){
		}else if(msg == WM_NCRBUTTONDOWN){
		}else if(msg == WM_NCRBUTTONUP){
		}else if(msg == WM_NCRBUTTONDBLCLK){
		}else if(msg == WM_NCMBUTTONDOWN){
		}else if(msg == WM_NCMBUTTONUP){
		}else if(msg == WM_NCMBUTTONDBLCLK){
		}else
			goto label_call;
	}

	label_start:

	if(msg == WM_LBUTTONDOWN){
		TGrpButtonItem* t= frm_main->bg_tools->Items->Items[frm_main->bg_tools->ItemIndex];
		OutputDebugStringA(t->Caption.c_str());
		if(t->Caption == "Pointer"){
			//if(frm_main->bg_tools->ItemIndex == 0){
			HWND hwnd_sel = NULL;

			hwnd_sel = windowFormPoint(hwnd_topWin);
			frm_main->select(hwnd_sel);
			lbutton = true;

			::GetCursorPos(&backPos);
		}else{
			POINT pos;

			::GetCursorPos(&pos);
			ScreenToClient(hwnd_topWin, &pos);

			frm_main->createRect.left = pos.x;
			frm_main->createRect.top = pos.y;
			lcreate = true;
		}
	}else if(msg == WM_KEYDOWN){
		if(VK_DELETE == wParam){
			if(frm_main->hwnd_select != (HWND)frm_main->page_win->ActivePage->Tag){
				ShowWindow(frm_main->hwnd_select, SW_HIDE);
				DestroyWindow(frm_main->hwnd_select);
				frm_main->select(NULL);
			}
		}
	}else if(msg == WM_MOUSEMOVE){
		if((wParam & MK_LBUTTON)&&(lbutton == true)){

			POINT pos;
			GetCursorPos(&pos);

			if((pos.x != backPos.x)||(pos.y != backPos.y)){
				frm_main->HideMoveBoxs();
			}

			RECT rect;
			GetWindowRect(frm_main->hwnd_select, &rect);
			ScreenToClientRect(hwnd_topWin, rect);

			if(frm_main->hwnd_select != hwnd_topWin){
				SetWindowPos(frm_main->hwnd_select , NULL, rect.left +(pos.x - backPos.x) ,rect.top +(pos.y - backPos.y), 0, 0, SWP_NOSIZE);
				InvalidateRect(frm_main->hwnd_select , NULL, TRUE);
				backPos = pos;
			}
		}
	}else if(msg == WM_LBUTTONUP){
		if(lbutton == true){
			frm_main->select(frm_main->hwnd_select);
			lbutton = false;
		}else if(lcreate == true){
			TGrpButtonItem* t= frm_main->bg_tools->Items->Items[frm_main->bg_tools->ItemIndex];

			POINT pos;

			::GetCursorPos(&pos);
			ScreenToClient(hwnd_topWin, &pos);

			frm_main->createRect.right = pos.x;
			frm_main->createRect.bottom = pos.y;

			HWND sel_hwnd = frm_main->MakeControl(hwnd_topWin, t->Caption , frm_main->createRect);

			frm_main->bg_tools->ItemIndex = 0;
			frm_main->select(sel_hwnd);

			lcreate = false;
		}
	}else if(msg == WM_SIZE){
	}else if(msg == WM_NCLBUTTONDOWN){
		SetActiveWindow(hWnd);
		//SendMessageA(hWnd, WM_NCHITTEST, 0, 0);
		msg = WM_LBUTTONDOWN;
		goto label_start;
	}else if(msg == WM_NCLBUTTONUP){
		msg = WM_LBUTTONUP;
		goto label_start;
	}else if(msg == WM_NCLBUTTONDBLCLK){
	}else if(msg == WM_NCRBUTTONDOWN){
	}else if(msg == WM_NCRBUTTONUP){
	}else if(msg == WM_NCRBUTTONDBLCLK){
	}else if(msg == WM_NCMBUTTONDOWN){
	}else if(msg == WM_NCMBUTTONUP){
	}else if(msg == WM_NCMBUTTONDBLCLK){
	}else if(msg == WM_RBUTTONDOWN){
	}else if(msg == WM_RBUTTONUP){
	}else if(msg == WM_LBUTTONDBLCLK){
	}else if(msg == WM_RBUTTONDBLCLK){
	}else if(msg == WM_KEYUP){
	}else if(msg == WM_CHAR){
	}else if(msg == WM_INITMENU){
	}else if(msg == WM_INITMENUPOPUP){
	}else if(msg == WM_COMMAND){
	}else if(msg == WM_NOTIFY){
	}else if(msg == WM_HELP){

	}else{
		label_call:
		return CallWindowProc((int(__stdcall *)())frm_main->map_funaddr[hWnd], hWnd, msg, wParam, lParam);
	}



	label_exit:
	return 0;
}

void __fastcall Tfrm_main::psResize(TObject *Sender){
//	TScrollBox *t = (TScrollBox *)Sender;
//	t->Controls[0]->Height = t->Height;
//	t->Controls[0]->Width = t->Width;
}

int CALLBACK fun_enumchildwin_windowFormPoint(HWND hwnd, HWND *result){
	RECT rect;
	POINT pos;

	GetCursorPos(&pos);
	GetWindowRect(hwnd, &rect);

	if(((pos.x >= rect.left)&&(pos.x <= rect.right ))&&
			((pos.y >= rect.top) && (pos.y <= rect.bottom))){
		*result = hwnd;
		return FALSE;
	}
	return TRUE;
}

HWND windowFormPoint(HWND hwnd){
	POINT pos;
	HWND result = NULL;

	GetCursorPos(&pos);
	result = WindowFromPoint(pos);

	if(result == hwnd){
		EnumChildWindows(hwnd, (int(__stdcall *)())fun_enumchildwin_windowFormPoint, (DWORD)&result);
	}

	return result;
}

int DeleteControl(HWND hwnd){
	ShowWindow(hwnd, SW_HIDE);
	DestroyWindow(hwnd);
	frm_main->select(NULL);

	//Ƽ ޸ .. .. &&&&

	map<String, HWND>::iterator i = frm_main->map_nameToHandle.begin();//findȵǼ;;
	for(;i != frm_main->map_nameToHandle.end(); i++){
		if(i->second == hwnd){
			frm_main->map_nameToHandle.erase(i);
			break;
		}
	}

	frm_main->map_hwndToEvent.erase(hwnd);
	frm_main->map_funaddr.erase(hwnd);
	frm_main->map_obj.erase(hwnd);


	return 0;
}

LRESULT CALLBACK HookProc(int code, WPARAM wParam, LPARAM lParam){
	static bool lbutton = false;
	static POINT backPos = {0,};
	static bool lcreate = false;

	if(code >= 0){
		MSG* msg = (MSG *)lParam;

		HWND phwnd = GetParent(msg->hwnd);
		while(GetParent(phwnd) != NULL){
        	phwnd = GetParent(phwnd);
		}

		if(phwnd == NULL){
			phwnd = msg->hwnd;
		}

		if(find(frm_main->m_wins.begin(),frm_main->m_wins.end(), phwnd) == frm_main->m_wins.end()){
			goto label_exit;
		}
		if(msg->message == WM_KEYDOWN){
			if(VK_DELETE == msg->wParam){
				if(frm_main->hwnd_select != (HWND)frm_main->page_win->ActivePage->Tag){
					DeleteControl(frm_main->hwnd_select);
				}
			}
		}
	}

	label_exit:
	return CallNextHookEx(0, code, wParam, lParam);
}


int Tfrm_main::IDE_addObj(String name, HWND hwnd){
	MAP_ATT *t = new MAP_ATT;
	MAP_EVENT *e = new MAP_EVENT;

	map_nameToHandle[name] = hwnd;
	(*t)["Name"] = name;

	map_obj[hwnd] = (void*)t;
	map_hwndToEvent[hwnd] = (void*)e;


	DWORD proc = GetWindowLongA(hwnd, GWL_WNDPROC);

	map_funaddr[hwnd] = (void *)proc;

	return 0;
}


int SetButtonAtt(HWND hwnd, MAP_ATT &t){

	t["Font"] = "";
	t["Font Color"] = "0xFFFFFF";


	t["Align"] = "AL_LEFT";
	if(SendMessageA(hwnd, BM_GETCHECK, 0, 0)){
		t["Check"] = "TRUE";
	}else{
		t["Check"] = "FALSE";
    }
	return 0;
}


int SetPicAtt(HWND hwnd, MAP_ATT &t){

	t["Picture Handle"] = "";
	t["Picture"] = "";
	return 0;
}

int SetEditAtt(HWND hwnd, MAP_ATT &t){
	DWORD style = GetWindowLongA(hwnd, GWL_STYLE);

	t["Text"] = t["Caption"];

	if(style & ES_MULTILINE){
		t["Multi Line"] = "TRUE";
	}else{
		t["Multi Line"] = "FALSE";
	}

	t["Password Char"] = "";

	if(style & ES_READONLY){
		t["Read Only"] = "TRUE";
	}else{
		t["Read Only"] = "FALSE";
	}
	
	int max = SendMessage(hwnd, EM_GETLIMITTEXT ,0 ,0);

	t["Max Length"] = max;

	t["Font"] = "";

	t["Font Color"] = "0xFFFFFF";


	t["Align"] = "AL_LEFT";

	return 0;
}

int SetComboAtt(HWND hwnd, MAP_ATT &t){
	t["Text"] = t["Caption"];
	t["Lines"] = "";

	t["Align"] = "AL_LEFT";
	t["Font"] = "";
	t["Font Color"] = "0xFFFFFF";

	return 0;
}

int SetListAtt(HWND hwnd, MAP_ATT &t){
	t["Lists"] = "";

	t["Align"] = "AL_LEFT";
	t["Font"] = "";
	t["Font Color"] = "0xFFFFFF";
	return 0;
}

int SetStaticAtt(HWND hwnd, MAP_ATT &t){
	t["Text"] = t["Caption"];
	t["Align"] = "AL_LEFT";
	t["Font"] = "";
	t["Font Color"] = "0xFFFFFF";

	return 0;
}

int SetBaseAtt(HWND hwnd, MAP_ATT &t){
	//Top//Left//Wdith//Height//ID//Font//Tooltip
	//Visible//Enable//Caption//Class Name


	char temp[256];


	RECT rect;
	::GetWindowRect(hwnd, &rect);

	if(GetParent(hwnd) != NULL){
		HWND h = GetParent(hwnd);
		ScreenToClientRect(h, rect);
	}

	t["Top"]	= rect.top;
	t["Left"]	= rect.left;
	t["Width"]	= rect.right - rect.left;
	t["Height"]	= rect.bottom - rect.top;

	//ID
	t["ID"]		= GetWindowLongA(hwnd, GWL_ID);

	//Handle
	t["Handle"] = (DWORD)hwnd;

	//Font
	t["Font"]	= "";

	//Tooltip
	t["Tooltip"]= "";

	//default Cognition
	t["Cognition"]	= "ID";

	//Caption
	GetWindowTextA(hwnd, temp, sizeof(temp));
	t["Caption"] = temp;


	//Class Name
	GetClassNameA(hwnd, temp, sizeof(temp));
	t["Class"] = temp;

	DWORD style = GetWindowLongA(hwnd, GWL_STYLE);

	//Enable
	if(style & WS_DISABLED){
		t["Enable"] = "FALSE";
	}else{
		t["Enable"] = "TRUE";
	}

	//Visible
	if(style & WS_VISIBLE){
		t["Visible"] = "TRUE";
	}else{
		t["Visible"] = "FALSE";
	}

	//Boder
	if(style & WS_BORDER){
		t["Boder"] = "TRUE";
	}else{
		t["Boder"] = "FALSE";
	}

	t["Boder Size"] = "1";

	t["Events"] = "";

	t["OrgTop"] = t["Top"];
	t["OrgLeft"] = t["Left"];
	t["OrgHeight"] = t["Height"];
	t["OrgWidth"] = t["Width"];
	t["OrgID"] = t["ID"];

	//t["OrgSec"]
	//t["OrgOff"]

	return 0;
}

int IDE_regWindow(HWND hwnd){

	static DWORD cnt_button	= 0;
	static DWORD cnt_edit	= 0;
	static DWORD cnt_combo	= 0;
	static DWORD cnt_list	= 0;
	static DWORD cnt_static = 0;
	static DWORD cnt_other	= 0;


	char str[256];
	String name;

	GetClassName(hwnd, str, sizeof(str));

	if( ((String)str).LowerCase() == "button"){

		name.sprintf(L"%s%d","button", cnt_button);
		cnt_button++;
	}else if( ((String)str).LowerCase() == "edit"){
		name.sprintf(L"%s%d","edit", cnt_edit);
		cnt_button++;
	}else if( ((String)str).LowerCase() == "combobox"){
		name.sprintf(L"%s%d","combobox", cnt_combo);
		cnt_button++;
	}else if( ((String)str).LowerCase() == "listbox"){
		name.sprintf(L"%s%d","listbox", cnt_list);
		cnt_button++;
	}else if( ((String)str).LowerCase() == "static"){
		name.sprintf(L"%s%d","static", cnt_static);
		cnt_button++;
	}else{
		name.sprintf(L"%s%d","other", cnt_other);
		cnt_button++;
	}

	frm_main->IDE_addObj(name, hwnd);

	//Visible:IDE  켱̰Ѵ
	DWORD style = GetWindowLongA(hwnd, GWL_STYLE);
	style |= WS_VISIBLE;
	SetWindowLongA(hwnd, GWL_STYLE, style);
	/////////////////////////////////////////////////

	SetBaseAtt(hwnd, *((MAP_ATT*)frm_main->map_obj[hwnd]));


	//MessageBox(NULL,str,"",MB_OK);
	if( ((String)str).LowerCase() == "button"){
		SetButtonAtt(hwnd, *((MAP_ATT*)frm_main->map_obj[hwnd]));
	}else if( ((String)str).LowerCase() == "edit"){
		SetEditAtt(hwnd, *((MAP_ATT*)frm_main->map_obj[hwnd]));
	}else if( ((String)str).LowerCase() == "combobox"){
		SetComboAtt(hwnd, *((MAP_ATT*)frm_main->map_obj[hwnd]));
	}else if( ((String)str).LowerCase() == "listbox"){
		SetListAtt(hwnd, *((MAP_ATT*)frm_main->map_obj[hwnd]));
	}else if( ((String)str).LowerCase() == "static"){
		SetStaticAtt(hwnd, *((MAP_ATT*)frm_main->map_obj[hwnd]));
	}else if( ((String)str).LowerCase() == "picturebox"){
		SetPicAtt(hwnd, *((MAP_ATT*)frm_main->map_obj[hwnd]));
	}


	SetWindowLongA(hwnd, GWL_WNDPROC, (DWORD)fun_HookProc);

	return 0;
}


int CALLBACK fun_enumchildwinToAdd(HWND hwnd, LPARAM l){
	IDE_regWindow(hwnd);
	return TRUE;
}

int CALLBACK fun_enumwin(HWND hwnd, LPARAM l){
	DWORD pid;
	DWORD npid = GetCurrentProcessId();

	if(IsWindowVisible(hwnd) == TRUE){

		GetWindowThreadProcessId(hwnd, &pid);

		if(pid == npid){

			DWORD thid = GetWindowThreadProcessId(hwnd, NULL);
			if(GetCurrentThreadId() != thid){
				frm_main->addEditingWindow(hwnd, thid);
			}
		}
	}

	return TRUE;
}


int Tfrm_main::select(HWND hwnd){
	static int a = 0;

	char temp[256];

	String classname;

	hwnd_select = hwnd;

	vle_attribute->Strings->Text = "";//ʱȭ

	if(hwnd_select == NULL){
		HideMoveBoxs();
		return 0;
	}
	HideMoveBoxs();
	DrawMoveBoxs();





	MAP_ATT &t = *(MAP_ATT *)map_obj[hwnd_select];

	MAP_ATT::iterator i = t.begin();
	for(;i != t.end();i++){
		String attname = i->first;

		if(map_kindOfAtt.find(attname) != map_kindOfAtt.end()){
		   string mem = map_kindOfAtt[attname].c_str();
		   int pos = mem.find_first_of('|');
		   string index = mem.substr(0, pos);

		   string body = mem.substr(pos + 1, mem.length());

		   int f = vle_attribute->InsertRow( attname, i->second, TRUE) - 1;

		   if(index == "Combo"){
				vle_attribute->ItemProps[f]->ReadOnly = TRUE;
				vle_attribute->ItemProps[f]->EditStyle = esPickList;
				int p = 0;
				int back = 0;

				while(body.find(',', p + 1) != string::npos){
					p = body.find(',', p + 1);
					string s = body.substr(back, p - back);

					vle_attribute->ItemProps[f]->PickList->Add(s.c_str());

					back = p + 1;
				}

				string s = body.substr(back, body.length() - back);

				vle_attribute->ItemProps[f]->PickList->Add(s.c_str());
		   }if(index == "Font"){
				vle_attribute->ItemProps[f]->EditStyle = esEllipsis;
		   }if(index == "Color"){
				vle_attribute->ItemProps[f]->EditStyle = esEllipsis;
		   }if(index == "Code"){
				vle_attribute->ItemProps[f]->EditStyle = esEllipsis;
		   }if(index == "Num"){
				vle_attribute->ItemProps[f]->EditMask = "#######; ; ";
		   }if(index == "Char"){
				vle_attribute->ItemProps[f]->MaxLength = 1;
		   }if(index == "Hide"){
		   }

		}else{

			vle_attribute->Values[attname] = i->second;

		}
	}


/*
	//name
	vle_attribute->InsertRow("Name", "", TRUE);

	DWORD id = GetWindowLongA(hwnd, GWL_ID);
	wsprintf(temp, "%d", id);
	vle_attribute->InsertRow("ID", temp, TRUE);

	wsprintf(temp, "%d", hwnd);
	vle_attribute->InsertRow("Handle", temp, TRUE);

	GetWindowTextA(hwnd, temp, sizeof(temp));
	vle_attribute->InsertRow("Caption", temp, TRUE);

	RECT rect;
	::GetWindowRect(hwnd, &rect);

	ScreenToClientRect((HWND)page_win->ActivePage->Tag, rect);


	GetClassNameA(hwnd, temp, sizeof(temp));
	classname = temp;
	vle_attribute->InsertRow("Class Name" , temp, TRUE);

	wsprintf(temp, "%d", rect.top);
	vle_attribute->InsertRow("TOP", temp, TRUE);

	wsprintf(temp, "%d", rect.left);
	vle_attribute->InsertRow("Left", temp, TRUE);

	wsprintf(temp, "%d", rect.right);
	vle_attribute->InsertRow("Right", temp, TRUE);

	wsprintf(temp, "%d", rect.bottom);
	vle_attribute->InsertRow("Bottom", temp, TRUE);


	DWORD style = GetWindowLongA(hwnd, GWL_STYLE);
	if(style & WS_DISABLED){
		vle_attribute->InsertRow("Enable", "FALSE", TRUE);
	}else{
		vle_attribute->InsertRow("Enable", "TRUE", TRUE);
	}

	if(style & WS_VISIBLE){
		vle_attribute->InsertRow("Visible", "True", TRUE);
	}else{
		vle_attribute->InsertRow("Visible", "False", TRUE);
	}


	vle_attribute->InsertRow("Events", "", TRUE);

	classname = classname.LowerCase();
	if(classname == "button"){
		//DWORD style = GetWindowLongA(hwnd, GWL_STYLE);
		if(style & BS_RADIOBUTTON){
			vle_attribute->Values["Check"] = "True";
		}else if(style & BS_CHECKBOX){
			vle_attribute->Values["Check"] = "True";
		}else if(style & BS_GROUPBOX){
			//vle_attribute->Values["׷"] = "";
		}else{
			vle_attribute->Values["ư"] = "";
		}
	}else if(classname == "edit"){
		GetWindowTextA(hwnd, temp, sizeof(temp));
		vle_attribute->Values["Text"] = temp;

		if(style & WS_VISIBLE){
			vle_attribute->Values["MultyLine"] = "TRUE";
		}else{
			vle_attribute->Values["MultyLine"] = "FALSE";
		}

	}


*/
	return 0;
}


int Tfrm_main::addEditingWindow(HWND hwnd, DWORD tid){
	char str_name[256];

	GetWindowTextA(hwnd, str_name, sizeof(str_name));

	wsprintf(str_name , "%s(HANDLE:%d)",str_name ,hwnd);

	/////////////////////////////////////////////page tab ߰Ѵ
	TIcon *icon = new TIcon;
	icon->Handle = (HICON)GetClassLongA(hwnd, GCL_HICON);
	imglist_icon->InsertIcon(imglist_icon->Count, icon);
	icon->ReleaseHandle();
	delete icon;

	TTabSheet* Tabsheet = new TTabSheet(frm_main->page_win);
	Tabsheet->Caption = str_name;
	Tabsheet->ImageIndex = imglist_icon->Count - 1;
	Tabsheet->Tag = (DWORD)hwnd;
	Tabsheet->PageControl = frm_main->page_win;
	///////////////////////////////////////////////////////////////

	/////////////////////////////////////////////ũ ڽ ߰Ѵ
	TScrollBox *sb = new TScrollBox(this);
	//sb->OnResize
	sb->Top = 0;
	sb->Left = 0;

	sb->Height = Tabsheet->Height;
	sb->Width = Tabsheet->Height;

	sb->Parent = Tabsheet;
	///////////////////////////////////////////////////////////////////

	TPanel *tp = new TPanel(this);

	tp->Top = 0;
	tp->Left = 0;

	tp->Height = sb->Height;
	tp->Width = sb->Width;

	tp->Parent = sb;
	sb->OnResize = psResize;

	RECT rect;
	GetWindowRect(hwnd, &rect);
	tp->Width = rect.right - rect.left;
	tp->Height = rect.bottom - rect.top;

	////////////////////////////////////////////////////////docking

	::SetParent(hwnd, tp->Handle);
	SetWindowPos(hwnd, 0, 0,0,0,0,SWP_NOSIZE);
	///////////////////////////////////////////////////////////////

	//////////////////////////////Visible:IDE  켱̰Ѵ
	DWORD style = GetWindowLongA(hwnd, GWL_STYLE);
	style |= WS_VISIBLE;
	SetWindowLongA(hwnd, GWL_STYLE, style);
	///////////////////////////////////////////////////////////////

	//Hook map 
	m_wins.insert(m_wins.begin(), hwnd);

	///////////////////////////////////////////////////ڽڽ 
	static DWORD cnt_window = 0;
	String name;

	name.sprintf(L"%s%d","Window", cnt_window);
	IDE_addObj(name, hwnd);

	/////////////////////////////////////////////////

	SetBaseAtt(hwnd, *((MAP_ATT*)map_obj[hwnd]));

	SetWindowLongA(hwnd, GWL_WNDPROC, (DWORD)fun_HookProc);

	/////////////////////////////////////////////////////////////////


	EnumChildWindows(hwnd,(int(CALLBACK *)())fun_enumchildwinToAdd,NULL);
	SetWindowsHookExA(WH_GETMESSAGE ,(int(__stdcall *)())HookProc, global::hinst, tid);
	//SetWindowsHookExA(WH_CALLWNDPROC ,(int(__stdcall *)())HookProc, global::hinst, tid);

	//SetWindowsHookExA(WH_CALLWNDPROC ,(int(__stdcall *)())HookProc, hinst, tid);
	//SetWindowsHookExA(WH_CBT ,(int(__stdcall *)())HookProc, global::hinst, tid);
	////////////////////////////////////////////////////////////////

	return 0;
}
//---------------------------------------------------------------------------
__fastcall Tfrm_main::Tfrm_main(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
int Tfrm_main::clearEditingWindow(){
	return 0;
}

int Tfrm_main::setEditingWindow(){
	::EnumWindows((int(__stdcall *)())fun_enumwin, 0);
	return 0;
}

void __fastcall Tfrm_main::FormShow(TObject *Sender)
{
	frm_remote->Destroying();
	SendMessage(this->Handle, WM_SIZE, 0, 0);

	p_lb->Parent = page_win;
	p_cb->Parent = page_win;
	p_rb->Parent = page_win;
	p_rt->Parent = page_win;
	p_ct->Parent = page_win;
	p_lt->Parent = page_win;
	p_lc->Parent = page_win;
	p_rc->Parent = page_win;

	frm_rc->Show();


}
//---------------------------------------------------------------------------
void __fastcall Tfrm_main::img_titlecenterMouseDown(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{
	ReleaseCapture();
	SendMessageA(this->Handle, WM_NCLBUTTONDOWN, HTCAPTION, 0);
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_main::img_titleleftMouseDown(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{
	ReleaseCapture();
	SendMessageA(this->Handle, WM_NCLBUTTONDOWN, HTCAPTION, 0);
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_main::img_titlerightMouseDown(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{
	ReleaseCapture();
	SendMessageA(this->Handle, WM_NCLBUTTONDOWN, HTCAPTION, 0);
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_main::img_titlecenterDblClick(TObject *Sender)
{
	WINDOWPLACEMENT infor;

	GetWindowPlacement(this->Handle, &infor);
	if(infor.showCmd == SW_SHOWMAXIMIZED){
		ShowWindow(this->Handle, SW_NORMAL);
	}else{
		ShowWindow(this->Handle, SW_MAXIMIZE);
	}

}
//---------------------------------------------------------------------------
void __fastcall Tfrm_main::FormResize(TObject *Sender)
{
	img_titleleft->Left = 0;
	img_titleright->Left = this->Width - img_titleright->Width;
	img_titlecenter->Width = img_titleright->Left - img_titlecenter->Left;

	sp_close->Top = 5;
	sp_close->Left = this->Width - 5 - sp_close->Width;

	sp_max->Top = 5;
	sp_max->Left = sp_close->Left - 2 - sp_close->Width;

	sp_min->Top = 5;
	sp_min->Left = sp_max->Left - 2 - sp_close->Width;

//	sp_right->Top = img_titlecenter->Height;
//	sp_right->Left = this->Width - 2;
//	sp_right->Height = this->Height - 4;


//	sp_left->Left = 0;
//	sp_left->Top = img_titlecenter->Height;
//	sp_left->Height = this->Height - 4;

	//г resize

	p_tools->Top = img_top->Top + img_top->Height + 1;
	p_tools->Height = this->Height - p_tools->Top - 1;

	bg_menu->Width = this->Width - bg_menu->Left - 4;

	p_attribute->Left = this->Width - p_attribute->Width - 4;
	p_attribute->Top = img_top->Top + img_top->Height + 1;
	p_attribute->Height = this->Height - p_attribute->Top - 1;

	page_win->Left = p_tools->Left + p_tools->Width;
	page_win->Top = img_top->Top + img_top->Height - 1;
	page_win->Width = p_attribute->Left - page_win->Left;
	page_win->Height = this->Height - page_win->Top - 1;

	//̹ resize
	img_top->Left = 2;
	img_top->Width = this->Width - 4;

	//
	select(hwnd_select);
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_main::bg_menuClick(TObject *Sender)
{
	this->bg_menu->ItemIndex = -1;
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_main::s_backgMouseDown(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{

#define SC_DRAG_RESIZEL  0xf001  // left resize
#define SC_DRAG_RESIZER  0xf002  // right resize
#define SC_DRAG_RESIZEU  0xf003  // upper resize
#define SC_DRAG_RESIZEUL 0xf004  // upper-left resize
#define SC_DRAG_RESIZEUR 0xf005  // upper-right resize
#define SC_DRAG_RESIZED  0xf006  // down resize
#define SC_DRAG_RESIZEDL 0xf007  // down-left resize
#define SC_DRAG_RESIZEDR 0xf008  // down-right resize
#define SC_DRAG_MOVE     0xf012  // move

	Tfrm_main *SenderControl = (Tfrm_main *)Sender;

	int SysCommWparam = 0;

	if(X < 5 && Y < 5)
		SysCommWparam = SC_DRAG_RESIZEUL;
	else if(X > SenderControl->Width-5 && Y > SenderControl->Height-5)
		SysCommWparam = SC_DRAG_RESIZEDR;
	else if(X < 5 && Y > SenderControl->Height-5)
		SysCommWparam = SC_DRAG_RESIZEDL;
	else if(X > SenderControl->Width-5 && Y < 5)
		SysCommWparam = SC_DRAG_RESIZEUR;
	else if(X < 5)
		SysCommWparam = SC_DRAG_RESIZEL;
	else if(X > SenderControl->Width-5)
		SysCommWparam = SC_DRAG_RESIZER;
	else if(Y < 5)
		SysCommWparam = SC_DRAG_RESIZEU;
	else if(Y > SenderControl->Height-5)
		SysCommWparam = SC_DRAG_RESIZED;
	//else
		//SysCommWparam = SC_DRAG_MOVE;

	ReleaseCapture();
	SendMessage(this->Handle, WM_SYSCOMMAND, SysCommWparam | 2, 0);
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_main::FormCanResize(TObject *Sender, int &NewWidth,
	  int &NewHeight, bool &Resize)
{
	if(NewWidth < 400)
		NewWidth = 400;
	if(NewHeight < 200)
		NewHeight = 200;
}
//---------------------------------------------------------------------------


void __fastcall Tfrm_main::p_attributeResize(TObject *Sender)
{
	vle_attribute->Width = p_attribute->Width;
	vle_attribute->Height = p_attribute->Height;
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::FormCloseQuery(TObject *Sender, bool &CanClose)
{
	exit(0);
}
//---------------------------------------------------------------------------

int IsCanUseValuename(char* name){
	int i = 0;
	while(name[i] != NULL){

		if(!  (   (  (name[i] <= 'Z')&&(name[i] >= 'A')  )||
				  (  (name[i] <= 'z')&&(name[i] >= 'a')  )||
				  (  (name[i] <= '9')&&(name[i] >= '0')  )||
				  (name[i] == '_'))   ){
				return FALSE;
			}


		i++;
	}
	return TRUE;
}

int ChangeName(HWND hwnd, String name){
/*
	map<String,HWND>::iterator i;

	for(i = frm_main->map_nameToHandle.begin(); i != frm_main->map_nameToHandle.end(); i++){
		if(i->second == hwnd){
			frm_main->map_nameToHandle.erase(i);

			frm_main->map_nameToHandle[name] = hwnd;
			break;
		}
	}
*/
	return TRUE;
}


void __fastcall Tfrm_main::vle_attributeKeyPress(TObject *Sender, char &Key)
{
	if(Key == 13){
		IDE_eidtToMap();
	}else if(Key == VK_ESCAPE){
		MAP_ATT &t = *(MAP_ATT *)map_obj[hwnd_select];
		vle_attribute->Values[vle_attribute->Keys[vle_attribute->Row]] = t[vle_attribute->Keys[vle_attribute->Row]];
	}
}
//---------------------------------------------------------------------------


int Tfrm_main::DrawMoveBoxs(){
	
	RECT rect;

	GetWindowRect(hwnd_select, &rect);

	POINT topleft;
	POINT bottomright;

	DWORD l_wdith;
	DWORD l_height;

	l_wdith = rect.right - rect.left;
	l_height = rect.bottom - rect.top;

	topleft.x = rect.left;
	topleft.y = rect.top;

	bottomright.x = rect.right;
	bottomright.y = rect.bottom;

	//::ScreenToClient(this->Handle, &topleft);
	//::ScreenToClient(this->Handle, &bottomright);
	::ScreenToClient(page_win->Handle, &topleft);
	::ScreenToClient(page_win->Handle, &bottomright);



	p_lt->Top = topleft.y - 5;
	p_lt->Left = topleft.x - 5;

	p_rt->Top = topleft.y - 5;
	p_rt->Left = topleft.x + l_wdith;

	p_lb->Top = topleft.y + l_height;
	p_lb->Left = topleft.x - 5;

	p_rb->Top = topleft.y + l_height;
	p_rb->Left = topleft.x + l_wdith;

	///////////////////////////////////// ߰ġ ܹ


	DWORD hc = topleft.y + ((l_height / 2) - 2);
	DWORD wc = topleft.x + ((l_wdith / 2) - 2);

	if(hc > topleft.y){
		p_lc->Left = topleft.x - 5;
		p_lc->Top = hc;

		p_rc->Left = topleft.x + l_wdith;
		p_rc->Top = hc;
	}else{
		p_lc->Hide();
		p_rc->Hide();
	}

	if(wc > topleft.x){
		p_ct->Left = wc;
		p_ct->Top = topleft.y - 5;

		p_cb->Left = wc;
		p_cb->Top = topleft.y + l_height;
	}else{
		p_ct->Hide();
		p_cb->Hide();
	}


	///////////////////////////////////////////////////////////

	ShowMoveBoxs();
	
	return 0;
}




void __fastcall Tfrm_main::p_rcMouseMove(TObject *Sender, TShiftState Shift,
	  int X, int Y)
{
	TControl *t = (TControl *)Sender;
	if(hwnd_select == (HWND)page_win->ActivePage->Tag){
		return;
	}
	if (Shift != TShiftState() << ssLeft){
		t->Tag = FALSE;
		//select(hwnd_select);
		return;
	}

	if(t->Tag == TRUE){
		setRect("right");
	}
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::p_rcMouseDown(TObject *Sender, TMouseButton Button,
	  TShiftState Shift, int X, int Y)
{
	TControl *t = (TControl *)Sender;

	t->Tag = TRUE;
	HideMoveBoxs();
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::p_rcMouseUp(TObject *Sender, TMouseButton Button,
	  TShiftState Shift, int X, int Y)
{
	TControl *t = (TControl *)Sender;

	if(t->Tag == TRUE){
		setRect("right");
	}
	t->Tag = FALSE;
	select(hwnd_select);
}
//---------------------------------------------------------------------------
int Tfrm_main::ShowMoveBoxs(){
	p_lb->Show();
	p_lc->Show();
	p_lt->Show();

	p_cb->Show();
	p_ct->Show();

	p_rb->Show();
	p_rt->Show();
	p_rc->Show();
	return 0;
}

int Tfrm_main::HideMoveBoxs(){
	p_lb->Hide();
	p_lc->Hide();
	p_lt->Hide();

	p_cb->Hide();
	p_ct->Hide();

	p_rb->Hide();
	p_rt->Hide();
	p_rc->Hide();

	return 0;
}

int Tfrm_main::setRect(String index){
	RECT rect;
	POINT pos;

	HWND phwnd = GetParent(hwnd_select);

	GetCursorPos(&pos);
	::GetWindowRect(hwnd_select, &rect);

	::ScreenToClientRect(phwnd , rect);
	::ScreenToClient(phwnd ,&pos);

	if(index == "up"){//up
		rect.top = pos.y;
	}else if(index == "down"){//down
		rect.bottom = pos.y;
	}else if(index == "left"){//left
		rect.left = pos.x;
	}else if(index == "right"){//right
		rect.right = pos.x;
	}else if(index == "upleft"){
		rect.top = pos.y;
		rect.left = pos.x;
	}else if(index == "upright"){
		rect.top = pos.y;
		rect.right = pos.x;
	}else if(index == "downleft"){
		rect.bottom = pos.y;
		rect.left = pos.x;
	}else if(index == "downright"){
		rect.bottom = pos.y;
		rect.right = pos.x;
	}else if(index == "upright"){
		rect.top = pos.y;
		rect.right = pos.x;
	}

	if(hwnd_select == (HWND)page_win->ActivePage->Tag){
		SetWindowPos(hwnd_select, 0, rect.left, rect.top, rect.right - rect.left , rect.bottom - rect.top , SWP_NOMOVE);

		TScrollBox *t = (TScrollBox *)page_win->ActivePage->Controls[0];
		t->Controls[0]->Height = rect.bottom - rect.top;
		t->Controls[0]->Width = rect.right - rect.left;

	}else{
		SetWindowPos(hwnd_select, 0, rect.left, rect.top, rect.right - rect.left , rect.bottom - rect.top , 0);
	}



	//HDC hdc = GetDC(hwnd_select);
	//Rectangle(hdc, rect.left, rect.top, rect.right, rect.bottom);
	//ReleaseDC(hwnd_select, hdc);

	//MoveWindow(hwnd_select, rect.left, rect.top, rect.right - rect.left , rect.bottom - rect.top , TRUE);
	return 0;
}

int Tfrm_main::DrawMoveShadow(String index){

	RECT rect;
	POINT pos;

	HWND phwnd = GetParent(hwnd_select);

	GetCursorPos(&pos);
	::GetWindowRect(hwnd_select, &rect);

	::ScreenToClientRect(phwnd , rect);
	::ScreenToClient(phwnd ,&pos);

	if(index == "up"){
		rect.top = pos.y;
	}else if(index == "down"){
		rect.bottom = pos.y;
	}else if(index == "left"){
		rect.left = pos.x;
	}else if(index == "right"){
		rect.right = pos.x;
	}else if(index == "upleft"){
		rect.top = pos.y;
		rect.left = pos.x;
	}else if(index == "upright"){
		rect.top = pos.y;
		rect.right = pos.x;
	}else if(index == "downleft"){
		rect.bottom = pos.y;
		rect.left = pos.x;
	}else if(index == "downright"){
		rect.bottom = pos.y;
		rect.right = pos.x;
	}else if(index == "upright"){
		rect.top = pos.y;
		rect.right = pos.x;
	}
	DWORD flag = 0;

	if(hwnd_select == (HWND)page_win->ActivePage->Tag){
		flag = SWP_NOMOVE;
	}

	HDC hdc = GetDC(hwnd_select);
	Rectangle(hdc, rect.left, rect.top, rect.right, rect.bottom);
	ReleaseDC(hwnd_select, hdc);

	//SetWindowPos(hwnd_select, 0, rect.left, rect.top, rect.right - rect.left , rect.bottom - rect.top , flag);
	//MoveWindow(hwnd_select, rect.left, rect.top, rect.right - rect.left , rect.bottom - rect.top , TRUE);
	return 0;

}


void __fastcall Tfrm_main::p_ctMouseDown(TObject *Sender, TMouseButton Button,
	  TShiftState Shift, int X, int Y)
{
	TControl *t = (TControl *)Sender;

	t->Tag = TRUE;
	HideMoveBoxs();
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::BitBtn1Click(TObject *Sender)
{
	HWND hwnd = (HWND)page_win->ActivePage->Tag;
	//ff = (LRESULT (CALLBACK *)(HWND, UINT, WPARAM , LPARAM ))GwtWindowLongA(hwnd, GWL_WNDPROC);
	//PostMessage(hwnd,WM_COMMAND,RMSG_INIT,0);
	SetWindowLongA(hwnd, GWL_WNDPROC, (long)fun_HookProc);
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::BitBtn2Click(TObject *Sender)
{
	HWND hwnd = (HWND)page_win->ActivePage->Tag;

}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::Button2Click(TObject *Sender)
{
	static long back = 0;
	HWND hwnd = (HWND)page_win->ActivePage->Tag;
	//ff = (LRESULT (CALLBACK *)(HWND, UINT, WPARAM , LPARAM ))GwtWindowLongA(hwnd, GWL_WNDPROC);
	//PostMessage(hwnd,WM_COMMAND,RMSG_INIT,0);
	if(ff == NULL){
//		ff = (LRESULT (CALLBACK *)(HWND, UINT, WPARAM , LPARAM ))SetWindowLongA(hwnd, GWL_WNDPROC, (long)WndProc1);
		ff = (WNDPROC)SetWindowLongA(hwnd, GWL_WNDPROC, (long)fun_HookProc);
	}else{
		SetWindowLongA(hwnd, GWL_WNDPROC, (long)ff);
		ff = NULL;
	}
}
//---------------------------------------------------------------------------





void __fastcall Tfrm_main::page_winResize(TObject *Sender)
{
	if(page_win->ActivePageIndex != -1){
		this->page_win->ActivePage->Controls[0]->Height = page_win->ActivePage->Height;
		this->page_win->ActivePage->Controls[0]->Width = page_win->ActivePage->Width;
	}
}
//---------------------------------------------------------------------------





void __fastcall Tfrm_main::p_cbMouseMove(TObject *Sender, TShiftState Shift,
	  int X, int Y)
{
	TControl *t = (TControl *)Sender;
	if(hwnd_select == (HWND)page_win->ActivePage->Tag){
		return;
	}
	if (Shift != TShiftState() << ssLeft){
		t->Tag = FALSE;
		//select(hwnd_select);
		return;
	}

	if(t->Tag == TRUE){
		setRect("down");
	}
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::p_ctMouseMove(TObject *Sender, TShiftState Shift,
	  int X, int Y)
{
	TControl *t = (TControl *)Sender;
	if(hwnd_select == (HWND)page_win->ActivePage->Tag){
		return;
	}
	if (Shift != TShiftState() << ssLeft){
		t->Tag = FALSE;
		//select(hwnd_select);
		return;
	}

	if(t->Tag == TRUE){
		setRect("up");
	}
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::p_lbMouseMove(TObject *Sender, TShiftState Shift,
	  int X, int Y)
{
	TControl *t = (TControl *)Sender;
	if(hwnd_select == (HWND)page_win->ActivePage->Tag){
		return;
	}
	if (Shift != TShiftState() << ssLeft){
		t->Tag = FALSE;
		//select(hwnd_select);
		return;
	}

	if(t->Tag == TRUE){
		setRect("downleft");
	}
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::p_lcMouseMove(TObject *Sender, TShiftState Shift,
	  int X, int Y)
{
	TControl *t = (TControl *)Sender;
	if(hwnd_select == (HWND)page_win->ActivePage->Tag){
		return;
	}
	if (Shift != TShiftState() << ssLeft){
		t->Tag = FALSE;
		//select(hwnd_select);
		return;
	}

	if(t->Tag == TRUE){
		setRect("left");
	}
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::p_ltMouseMove(TObject *Sender, TShiftState Shift,
	  int X, int Y)
{
	TControl *t = (TControl *)Sender;
	if(hwnd_select == (HWND)page_win->ActivePage->Tag){
		return;
	}
	if (Shift != TShiftState() << ssLeft){
		t->Tag = FALSE;
		//select(hwnd_select);
		return;
	}

	if(t->Tag == TRUE){
		setRect("upleft");
	}
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::p_rbMouseMove(TObject *Sender, TShiftState Shift,
	  int X, int Y)
{
	TControl *t = (TControl *)Sender;
	if(hwnd_select == (HWND)page_win->ActivePage->Tag){
		return;
	}
	if (Shift != TShiftState() << ssLeft){
		t->Tag = FALSE;
		//select(hwnd_select);
		return;
	}

	if(t->Tag == TRUE){
		setRect("downright");
	}
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::p_rtMouseMove(TObject *Sender, TShiftState Shift,
	  int X, int Y)
{
	TControl *t = (TControl *)Sender;
	if(hwnd_select == (HWND)page_win->ActivePage->Tag){
		return;
	}
	if (Shift != TShiftState() << ssLeft){
		t->Tag = FALSE;
		//select(hwnd_select);
		return;
	}

	if(t->Tag == TRUE){
		setRect("upright");
	}
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::p_cbMouseUp(TObject *Sender, TMouseButton Button,
	  TShiftState Shift, int X, int Y)
{
	TControl *t = (TControl *)Sender;

	if(t->Tag == TRUE){
		setRect("down");
	}
	t->Tag = FALSE;
	select(hwnd_select);
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::p_ctMouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
	TControl *t = (TControl *)Sender;

	if(t->Tag == TRUE){
		setRect("up");
	}
	t->Tag = FALSE;
	select(hwnd_select);
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::p_lbMouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
	TControl *t = (TControl *)Sender;

	if(t->Tag == TRUE){
		setRect("downleft");
	}
	t->Tag = FALSE;
	select(hwnd_select);
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::p_lcMouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
	TControl *t = (TControl *)Sender;

	if(t->Tag == TRUE){
		setRect("left");
	}
	t->Tag = FALSE;
	select(hwnd_select);
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::p_ltMouseUp(TObject *Sender, TMouseButton Button,
	  TShiftState Shift, int X, int Y)
{
	TControl *t = (TControl *)Sender;

	if(t->Tag == TRUE){
		setRect("upleft");
	}
	t->Tag = FALSE;
	select(hwnd_select);
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::p_rbMouseUp(TObject *Sender, TMouseButton Button,
	  TShiftState Shift, int X, int Y)
{
	TControl *t = (TControl *)Sender;

	if(t->Tag == TRUE){
		setRect("downright");
	}
	t->Tag = FALSE;
	select(hwnd_select);
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::p_rtMouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
	TControl *t = (TControl *)Sender;

	if(t->Tag == TRUE){
		setRect("upright");
	}
	t->Tag = FALSE;
	select(hwnd_select);
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::p_cbMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
	TControl *t = (TControl *)Sender;

	t->Tag = TRUE;
	HideMoveBoxs();
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::p_lbMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
	TControl *t = (TControl *)Sender;

	t->Tag = TRUE;
	HideMoveBoxs();
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::p_lcMouseDown(TObject *Sender, TMouseButton Button,
	  TShiftState Shift, int X, int Y)
{
	TControl *t = (TControl *)Sender;

	t->Tag = TRUE;
	HideMoveBoxs();
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::p_ltMouseDown(TObject *Sender, TMouseButton Button,
	  TShiftState Shift, int X, int Y)
{
	TControl *t = (TControl *)Sender;

	t->Tag = TRUE;
	HideMoveBoxs();
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::p_rbMouseDown(TObject *Sender, TMouseButton Button,
	  TShiftState Shift, int X, int Y)
{
	TControl *t = (TControl *)Sender;

	t->Tag = TRUE;
	HideMoveBoxs();
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::p_rtMouseDown(TObject *Sender, TMouseButton Button,
	  TShiftState Shift, int X, int Y)
{
	TControl *t = (TControl *)Sender;

	t->Tag = TRUE;
	HideMoveBoxs();
}
//---------------------------------------------------------------------------

HWND Tfrm_main::MakeControl(HWND phwnd, String index, RECT rect){
	/*
static
button
edit
combobox
listbox
//radio
	*/

	String classname;
	DWORD style = WS_CHILD | WS_VISIBLE;

	classname = index;

	if(index == "Static"){
		classname = "static";
	}else if(index == "Button"){
		classname = "button";
	}else if(index == "Edit"){
		classname = "edit";
		style |= WS_BORDER;
	}else if(index == "Memo"){
		classname = "edit";
		style |= WS_BORDER | ES_MULTILINE | ES_AUTOHSCROLL | ES_AUTOVSCROLL;
	}else if(index == "Combo Box"){
		classname = "combobox";
		style |= CBS_DROPDOWN | WS_BORDER;
	}else if(index == "List Box"){
		classname = "listbox";
		style |= WS_BORDER;
	}else if(index == "Radio Button"){
		classname = "button";
		style |= BS_AUTORADIOBUTTON;
	}else if(index == "timer"){
	}else if(index == "Check Button"){
		classname = "button";
		style |= BS_AUTOCHECKBOX;
	}else if(index == "Picture Box"){
		classname = "PictureBox";
		style |=  WS_BORDER;
	}else{
		MessageBeep(1000);
	}

	HWND h = CreateWindowExA(NULL, classname.c_str() , index.c_str(), style, rect.left,
					rect.top , rect.right - rect.left , rect.bottom - rect.top, phwnd,NULL, GetModuleHandleA(NULL),NULL);

	IDE_regWindow(h);


	return h;
}






void __fastcall Tfrm_main::sp_rightMouseDown(TObject *Sender, TMouseButton Button,
	  TShiftState Shift, int X, int Y)
{
	ReleaseCapture();
	SendMessageA(this->Handle, WM_NCLBUTTONDOWN, HTRIGHT, 0);
}
//---------------------------------------------------------------------------


void __fastcall Tfrm_main::sp_leftMouseDown(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{
	ReleaseCapture();
	SendMessageA(this->Handle, WM_NCLBUTTONDOWN, HTLEFT, 0);
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::sp_bottomMouseDown(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{
	ReleaseCapture();
	SendMessageA(this->Handle, WM_NCLBUTTONDOWN, HTBOTTOM, 0);
}
//---------------------------------------------------------------------------


void __fastcall Tfrm_main::sp_topMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
	ReleaseCapture();
	SendMessageA(this->Handle, WM_NCLBUTTONDOWN, HTTOP, 0);
}
//---------------------------------------------------------------------------


void __fastcall Tfrm_main::sp_closeMouseEnter(TObject *Sender)
{
	TShape *t = (TShape *)Sender;
	t->Pen->Style = psSolid;
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::sp_closeMouseLeave(TObject *Sender)
{
	TShape *t = (TShape *)Sender;
	t->Pen->Style = psClear;
}
//---------------------------------------------------------------------------


void __fastcall Tfrm_main::sp_closeMouseUp(TObject *Sender, TMouseButton Button,
	  TShiftState Shift, int X, int Y)
{
	exit(0);
}
//---------------------------------------------------------------------------


void __fastcall Tfrm_main::sp_minMouseUp(TObject *Sender, TMouseButton Button,
	  TShiftState Shift, int X, int Y)
{
	ShowWindow(this->Handle , SW_MINIMIZE);
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::sp_maxMouseUp(TObject *Sender, TMouseButton Button,
	  TShiftState Shift, int X, int Y)
{
	WINDOWPLACEMENT infor;

	GetWindowPlacement(this->Handle, &infor);
	if(infor.showCmd == SW_SHOWMAXIMIZED){
		ShowWindow(this->Handle, SW_NORMAL);
	}else{
		ShowWindow(this->Handle, SW_MAXIMIZE);
	}



}
//---------------------------------------------------------------------------

int SetAttList(map<String,String> &m){
	m["Visible"] = "Combo|TRUE,FALSE";
	m["Enable"] = "Combo|TRUE,FALSE";
	m["Read Only"] = "Combo|TRUE,FALSE";
	m["Multi Line"] = "Combo|TRUE,FALSE";
	m["Boder"] = "Combo|TRUE,FALSE";
	m["Check"] = "Combo|TRUE,FALSE";

	m["Align"] = "Combo|al_Left,al_Rgiht,al_Center";

	m["Cognition"] = "Combo|ID,Address,Rect";

	m["Font"] = "Font|";
	m["Password Char"] = "Char|";

	m["Top"] = "Num|";
	m["Left"] = "Num|";
	m["Height"] = "Num|";
	m["Width"] = "Num|";
	m["ID"] = "Num|";

	m["Max Length"] = "Num|";
	m["Boder Size"] = "Num|";

	m["Events"] = "Code|";
	m["Lines"] = "Code|";
	m["Picture"] = "Code|";

	m["OrgTop"] = "Hide|";
	m["OrgLeft"] = "Hide|";
	m["OrgHeight"] = "Hide|";
	m["OrgWidth"] = "Hide|";
	m["OrgID"] = "Hide|";
	m["OrgSec"] = "Hide|";
	m["OrgOff"] = "Hide|";

	return 0;
}

void __fastcall Tfrm_main::FormCreate(TObject *Sender)
{
	SetAttList(map_kindOfAtt);
}
//---------------------------------------------------------------------------
int apply(String name, String key, String value){

	HWND hwnd = frm_main->map_nameToHandle[name];
	String back = (*((MAP_ATT *)frm_main->map_obj[hwnd]))[key];

	if(key == (AnsiString)"Caption"){
		SetWindowTextA(hwnd, value.c_str());
	}else if(key == (AnsiString)"Top"){
		if((HWND)frm_main->page_win->ActivePage->Tag != hwnd){
			RECT rect;
			GetWindowRect(hwnd, &rect);
			ScreenToClientRect((HWND)frm_main->page_win->ActivePage->Tag, rect);

			rect.top = atoi(value.c_str());

			SetWindowPos(hwnd, NULL, rect.left, rect.top, rect.right - rect.left, rect.bottom - rect.top, SWP_NOACTIVATE);
		}
	}else if(key == (AnsiString)"Left"){
		if((HWND)frm_main->page_win->ActivePage->Tag != hwnd){
			RECT rect;
			GetWindowRect(hwnd, &rect);
			ScreenToClientRect((HWND)frm_main->page_win->ActivePage->Tag, rect);

			rect.left = atoi(value.c_str());

			SetWindowPos(hwnd, NULL, rect.left, rect.top, rect.right - rect.left, rect.bottom - rect.top, SWP_NOACTIVATE);
		}
	}else if(key == (AnsiString)"Width"){
		if((HWND)frm_main->page_win->ActivePage->Tag != hwnd){
			RECT rect;
			GetWindowRect(hwnd, &rect);
			ScreenToClientRect((HWND)frm_main->page_win->ActivePage->Tag, rect);

			SetWindowPos(hwnd, NULL, rect.left, rect.top, atoi(value.c_str()), rect.bottom - rect.top, SWP_NOACTIVATE);
		}
	}else if(key == (AnsiString)"Height"){
		if((HWND)frm_main->page_win->ActivePage->Tag != hwnd){
			RECT rect;
			GetWindowRect(hwnd, &rect);
			ScreenToClientRect((HWND)frm_main->page_win->ActivePage->Tag, rect);

			rect.bottom = atoi(value.c_str());

			SetWindowPos(hwnd, NULL, rect.left, rect.top, rect.right - rect.left, atoi(value.c_str()), SWP_NOACTIVATE);
		}
	}else if(key == (AnsiString)"Enable"){
		if(value != back){
			DWORD style = GetWindowLongA(hwnd, GWL_STYLE);

			if("TRUE" == value){
				style ^= WS_DISABLED;
			}else{
				style |= WS_DISABLED;
			}

			SetWindowLongA(hwnd, GWL_STYLE, style);
			InvalidateRect(hwnd , NULL, TRUE);
		}
	}else if(key == (AnsiString)"Font"){

	}else if(key == (AnsiString)"ID"){
		int i = atoi(value.c_str());
		SetWindowLongA(hwnd, GWL_ID, i);
	}else if(key == (AnsiString)"Max Length"){
		int i = atoi(value.c_str());
		SendMessage(hwnd, EM_SETLIMITTEXT, (WPARAM)i, 0);
	}else if(key == (AnsiString)"Password Char"){
		if(value != back){
			if(value == ""){
				SendMessageA(hwnd, EM_SETPASSWORDCHAR, NULL , 0);
			}else{
				SendMessageA(hwnd, EM_SETPASSWORDCHAR, (WPARAM)value.c_str()[0], 0);
			}
		}
	}else if(key == (AnsiString)"Read Only"){
		if("TRUE" == value){
			SendMessageA(hwnd, EM_SETREADONLY, TRUE, 0);
		}else{
			SendMessageA(hwnd, EM_SETREADONLY, FALSE, 0);
		}

	}else if(key == (AnsiString)"Text"){
		SetWindowTextA(hwnd, value.c_str());
	}else if(key == (AnsiString)"Visible"){
		if("TRUE" == value){
			ShowWindow(hwnd, SW_SHOW);
		}else{
			ShowWindow(hwnd, SW_HIDE);
		}
	}else if(key == (AnsiString)"Check"){
		//常 
		if("TRUE" == value){
			SendMessageA(hwnd, BM_SETCHECK, BST_CHECKED, 0);
		}else{
			SendMessageA(hwnd, BM_SETCHECK, BST_UNCHECKED, 0);
		}
	}

	(*((MAP_ATT *)frm_main->map_obj[hwnd]))[key] = value;

	return 0;
}

int Tfrm_main::IDE_eidtToMap(){

	AnsiString str_key = vle_attribute->Keys[vle_attribute->Row].c_str();

	String body = vle_attribute->Values[vle_attribute->Keys[vle_attribute->Row]];
	String back = (*((MAP_ATT *)map_obj[hwnd_select]))[vle_attribute->Keys[vle_attribute->Row]];


	if(str_key == (AnsiString)"Name"){//name
		String name = vle_attribute->Values[vle_attribute->Keys[vle_attribute->Row]];

		if(map_nameToHandle.find(name) != map_nameToHandle.end()){
			if(map_nameToHandle[name] != hwnd_select){
				MessageBoxA(this->Handle , "Ͻ Name ̹ մϴ. ߺǴ ڿ ̸ Ҽ ϴ.", "Error", MB_OK|MB_ICONERROR);
				return 0;
			}else{
				(*((MAP_ATT *)map_obj[hwnd_select]))[vle_attribute->Keys[vle_attribute->Row]] = vle_attribute->Values[vle_attribute->Keys[vle_attribute->Row]];
			}
		}

		if(IsCharAlphaA(name.c_str()[0]) != TRUE){
			MessageBoxA(this->Handle , "NameӼ ù ڴ ݵ ĺ(a~z, A~Z)̾ մϴ. ", "Error", MB_OK|MB_ICONERROR);
			return 0;
		}

		if(IsCanUseValuename(name.c_str()) != TRUE){
			MessageBoxA(this->Handle , "NameӼ ĺ  '_'ڸ   ֽϴ.", "Error", MB_OK|MB_ICONERROR);
			return 0;
		}

		//̸ 
		::ChangeName(hwnd_select, name);

	}else if(str_key == (AnsiString)"Handle"){//e
		if(	(*((MAP_ATT *)map_obj[hwnd_select]))[vle_attribute->Keys[vle_attribute->Row]] != vle_attribute->Values[vle_attribute->Keys[vle_attribute->Row]]){
			MessageBox(this->Handle, "HandleӼ   ϴ.", "Error", MB_OK|MB_ICONERROR);
			vle_attribute->Values[vle_attribute->Keys[vle_attribute->Row]] = (*((MAP_ATT *)map_obj[hwnd_select]))[vle_attribute->Keys[vle_attribute->Row]];
			return 0;
		}
	}else if(str_key == (AnsiString)"Caption"){
		//(*((MAP_ATT *)map_obj[hwnd_select]))[vle_attribute->Keys[vle_attribute->Row]] = vle_attribute->Values[vle_attribute->Keys[vle_attribute->Row]];
		SetWindowTextA(hwnd_select, vle_attribute->Values["Caption"].c_str());
	}else if(str_key == (AnsiString)"Class Name"){
		if(	(*((MAP_ATT *)map_obj[hwnd_select]))[vle_attribute->Keys[vle_attribute->Row]] != vle_attribute->Values[vle_attribute->Keys[vle_attribute->Row]]){
			MessageBox(this->Handle, "Class NameӼ   ϴ.", "Error", MB_OK|MB_ICONERROR);
			vle_attribute->Values[vle_attribute->Keys[vle_attribute->Row]] = (*((MAP_ATT *)map_obj[hwnd_select]))[vle_attribute->Keys[vle_attribute->Row]];
			return 0;
		}
	}else if(str_key == (AnsiString)"Top"){

		if((HWND)page_win->ActivePage->Tag != hwnd_select){
			RECT rect;
			GetWindowRect(hwnd_select, &rect);
			ScreenToClientRect((HWND)page_win->ActivePage->Tag, rect);

			rect.top = atoi(body.c_str());

			SetWindowPos(hwnd_select, NULL, rect.left, rect.top, rect.right - rect.left, rect.bottom - rect.top, SWP_NOACTIVATE);
		}
	}else if(str_key == (AnsiString)"Left"){
		if((HWND)page_win->ActivePage->Tag != hwnd_select){
			RECT rect;
			GetWindowRect(hwnd_select, &rect);
			ScreenToClientRect((HWND)page_win->ActivePage->Tag, rect);

			rect.left = atoi(body.c_str());

			SetWindowPos(hwnd_select, NULL, rect.left, rect.top, rect.right - rect.left, rect.bottom - rect.top, SWP_NOACTIVATE);
		}
	}else if(str_key == (AnsiString)"Width"){
		if((HWND)page_win->ActivePage->Tag != hwnd_select){
			RECT rect;
			GetWindowRect(hwnd_select, &rect);
			ScreenToClientRect((HWND)page_win->ActivePage->Tag, rect);

			SetWindowPos(hwnd_select, NULL, rect.left, rect.top, atoi(body.c_str()), rect.bottom - rect.top, SWP_NOACTIVATE);
		}
	}else if(str_key == (AnsiString)"Height"){
		if((HWND)page_win->ActivePage->Tag != hwnd_select){
			RECT rect;
			GetWindowRect(hwnd_select, &rect);
			ScreenToClientRect((HWND)page_win->ActivePage->Tag, rect);

			rect.bottom = atoi(body.c_str());

			SetWindowPos(hwnd_select, NULL, rect.left, rect.top, rect.right - rect.left, atoi(body.c_str()), SWP_NOACTIVATE);
		}
	}else if(str_key == (AnsiString)"Boder"){
		if(	(*((MAP_ATT *)map_obj[hwnd_select]))[vle_attribute->Keys[vle_attribute->Row]] != vle_attribute->Values[vle_attribute->Keys[vle_attribute->Row]]){
			MessageBox(this->Handle, "BoderӼ   ϴ.", "Error", MB_OK|MB_ICONERROR);
			vle_attribute->Values[vle_attribute->Keys[vle_attribute->Row]] = (*((MAP_ATT *)map_obj[hwnd_select]))[vle_attribute->Keys[vle_attribute->Row]];
			return 0;
		}
	}else if(str_key == (AnsiString)"Enable"){
		if(body != back){
			DWORD style = GetWindowLongA(hwnd_select, GWL_STYLE);

			if("TRUE" == body){
				style ^= WS_DISABLED;
			}else{
				style |= WS_DISABLED;
			}

			SetWindowLongA(hwnd_select, GWL_STYLE, style);
			InvalidateRect(hwnd_select , NULL, TRUE);
			//(*((MAP_ATT *)map_obj[hwnd_select]))[vle_attribute->Keys[vle_attribute->Row]] = body;
		}
	}else if(str_key == (AnsiString)"Font"){

	}else if(str_key == (AnsiString)"ID"){
		int i = atoi(body.c_str());
		SetWindowLongA(hwnd_select, GWL_ID, i);
	}else if(str_key == (AnsiString)"Max Length"){
		int i = atoi(body.c_str());
		SendMessage(hwnd_select, EM_SETLIMITTEXT, (WPARAM)i, 0);
	}else if(str_key == (AnsiString)"Multi Line"){
		if(	(*((MAP_ATT *)map_obj[hwnd_select]))[vle_attribute->Keys[vle_attribute->Row]] != vle_attribute->Values[vle_attribute->Keys[vle_attribute->Row]]){
			MessageBox(this->Handle, "Multi LineӼ   ϴ.", "Error", MB_OK|MB_ICONERROR);
			vle_attribute->Values[vle_attribute->Keys[vle_attribute->Row]] = (*((MAP_ATT *)map_obj[hwnd_select]))[vle_attribute->Keys[vle_attribute->Row]];
			return 0;
		}
	}else if(str_key == (AnsiString)"Password Char"){
		if(body != back){
			if(body == ""){
				SendMessageA(hwnd_select, EM_SETPASSWORDCHAR, NULL , 0);
			}else{
			MessageBeep(1000);
				SendMessageA(hwnd_select, EM_SETPASSWORDCHAR, (WPARAM)body.c_str()[0], 0);
			}
		}
	}else if(str_key == (AnsiString)"Read Only"){
		if("TRUE" == body){
			SendMessageA(hwnd_select, EM_SETREADONLY, TRUE, 0);
		}else{
			SendMessageA(hwnd_select, EM_SETREADONLY, FALSE, 0);
		}

	}else if(str_key == (AnsiString)"Text"){
		SetWindowTextA(hwnd_select, vle_attribute->Values["Caption"].c_str());
	}else if(str_key == (AnsiString)"Congnition"){
		if(	(*((MAP_ATT *)map_obj[hwnd_select]))[vle_attribute->Keys[vle_attribute->Row]] != vle_attribute->Values[vle_attribute->Keys[vle_attribute->Row]]){
			if(hwnd_select == (HWND)page_win->ActivePage->Tag){
				MessageBox(this->Handle, "Top Window  Caption ֽϴ.", "Error", MB_OK|MB_ICONERROR);
				return 0;
			}
		}
	}else if(str_key == (AnsiString)"Visible"){
		//常 
	}else if(str_key == (AnsiString)"Check"){
		//常 
		if("TRUE" == body){
			SendMessageA(hwnd_select, BM_SETCHECK, BST_CHECKED, 0);
		}else{
			SendMessageA(hwnd_select, BM_SETCHECK, BST_UNCHECKED, 0);
		}
	}

	(*((MAP_ATT *)map_obj[hwnd_select]))[vle_attribute->Keys[vle_attribute->Row]] = body;
	return 0;
}




void __fastcall Tfrm_main::bg_toolsButtonClicked(TObject *Sender, int Index)
{
	::SetCursor(LoadCursor(NULL,IDC_ARROW));
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::vle_attributeEditButtonClick(TObject *Sender)
{
	String str_key = vle_attribute->Keys[vle_attribute->Row].c_str();

	if(str_key == "Events"){
		frm_wizard->ShowWizard(hwnd_select, vle_attribute->Values["Name"]);
	}else if(str_key == "Picture"){
		dlg_pic->FileName = "";
		dlg_pic->Execute(this->Handle);
		if(dlg_pic->FileName != ""){
        	MessageBeep(1000);
			MAP_ATT &g = *(MAP_ATT *)frm_main->map_obj[hwnd_select];
			g["Picture"] = dlg_pic->FileName;

            select(hwnd_select);
		}
	}else if(str_key == "Font"){
		dlg_font->Execute();
		SendMessage(hwnd_select, WM_SETFONT, (WPARAM)dlg_font->Font->Handle, MAKELPARAM(TRUE, 0));
		MAP_ATT &g = *(MAP_ATT *)frm_main->map_obj[hwnd_select];
		g["Font"] = dlg_font->Font->Name;
	}
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::Button1Click(TObject *Sender)
{
	frm_code->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::bg_menuItems0Click(TObject *Sender)
{
	RECT rect;

	::GetWindowRect(frm_main->Handle, &rect);
	pop_file->Popup(rect.left + bg_menu->Left , rect.top + bg_menu->Top + bg_menu->Height);
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::bg_menuItems1Click(TObject *Sender)
{
	RECT rect;

	::GetWindowRect(frm_main->Handle, &rect);
	pop_edit->Popup(rect.left + bg_menu->Left + 81, rect.top + bg_menu->Top + bg_menu->Height);
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::bg_menuItems2Click(TObject *Sender)
{
	RECT rect;

	::GetWindowRect(frm_main->Handle, &rect);
	pop_view->Popup(rect.left + bg_menu->Left + (81* 2), rect.top + bg_menu->Top + bg_menu->Height);

}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::bg_menuItems3Click(TObject *Sender)
{
	RECT rect;

	::GetWindowRect(frm_main->Handle, &rect);
	pop_project->Popup(rect.left + bg_menu->Left + (81* 3), rect.top + bg_menu->Top + bg_menu->Height);

}
//---------------------------------------------------------------------------

void __fastcall Tfrm_main::bg_menuItems4Click(TObject *Sender)
{
	RECT rect;

	::GetWindowRect(frm_main->Handle, &rect);
	pop_help->Popup(rect.left + bg_menu->Left + (81* 4), rect.top + bg_menu->Top + bg_menu->Height);

}
//---------------------------------------------------------------------------

int saveDef(string filename){
	FILE *f = fopen( (filename+ ".def").c_str(), "wt");
	if(f == NULL){
		return 0;
	}

	map<HWND, void *> &m = frm_main->map_obj;
	map<HWND, void *>::iterator i = m.begin();

	for(;i != m.end();i++){
		MAP_ATT &t = *((MAP_ATT*)i->second);

		MAP_ATT::iterator nop = t.begin();

		fprintf(f, "%s %s\n", "["+t["Name"]+"]", "Name");

		for(;nop != t.end();nop++){
			if( nop->second != ""){
				fprintf(f, "%s %s\n", nop->first, nop->second);
			}
		}
	}

	fclose(f);

	return 0;
}


int saveCode(string filename){
	FILE *f = fopen( (filename+ ".code").c_str(), "wt");
	if(f == NULL){
		return 0;
	}

	fputs(global::str_code.c_str(), f);
	fclose(f);

	return 0;
}


int saveEvent(string filename){

	FILE *f = fopen( (filename+ ".event").c_str(), "wt");
	if(f == NULL){
		return 0;
	}

	map<HWND, void *> &m = frm_main->map_obj;
	map<HWND, void *>::iterator i = m.begin();

	for(;i != m.end();i++){
		MAP_ATT &t = *((MAP_ATT*)i->second);

		MAP_ATT::iterator nop = t.begin();

		fprintf(f, "%s %s\n", "["+t["Name"]+"]", "Name");

		for(;nop != t.end();nop++){
			if( nop->second != ""){
				fprintf(f, "%s %s\n", nop->first, nop->second);
			}
		}
	}

	fclose(f);

	return 0;
}


void __fastcall Tfrm_main::me_saveClick(TObject *Sender)
{
	dlg_save->FileName = "";
	dlg_save->Execute(this->Handle);
	if(dlg_save->FileName != ""){
		saveDef(dlg_save->FileName.c_str());
		//saveCode(dlg_save->FileName);
		//saveEvent(dlg_save->FileName);
	}
}
//---------------------------------------------------------------------------
