//---------------------------------------------------------------------------

#ifndef win_mainH
#define win_mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "global.h"
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <Menus.hpp>
#include <ActnList.hpp>
#include <ButtonGroup.hpp>
#include <ComCtrls.hpp>
#include <Grids.hpp>
#include <ValEdit.hpp>
#include <ToolWin.hpp>
#include <ImgList.hpp>
#include <Buttons.hpp>
#include <Dialogs.hpp>
#include <ExtDlgs.hpp>
#include <iostream>
#include <string>
#include <map>
#include <list>
#include <algorithm>
#include "win_wizard.h"

using namespace std;
//---------------------------------------------------------------------------
class Tfrm_main : public TForm
{
__published:	// IDE-managed Components
	TImage *img_titleleft;
	TImage *img_titlecenter;
	TImage *img_titleright;
	TPanel *p_tools;
	TActionList *ActionList1;
	TAction *Action1;
	TButtonGroup *bg_menu;
	TPageControl *page_win;
	TPanel *p_attribute;
	TValueListEditor *vle_attribute;
	TImage *img_top;
	TButtonGroup *bg_tools;
	TImageList *img_tools;
	TImageList *imglist_icon;
	TPanel *p_lt;
	TPanel *p_ct;
	TPanel *p_rt;
	TPanel *p_lb;
	TPanel *p_cb;
	TPanel *p_rb;
	TPanel *p_rc;
	TPanel *p_lc;
	TFontDialog *dl_font;
	TShape *sp_right;
	TShape *sp_left;
	TShape *sp_bottom;
	TShape *sp_top;
	TShape *sp_close;
	TShape *sp_max;
	TShape *sp_min;
	TButton *Button1;
	TPopupMenu *pop_file;
	TMenuItem *me_save;
	TMenuItem *me_exit;
	TPopupMenu *pop_view;
	TMenuItem *ShowRemoteControl1;
	TPopupMenu *pop_project;
	TMenuItem *Build1;
	TMenuItem *Option1;
	TPopupMenu *pop_help;
	TMenuItem *About1;
	TMenuItem *Help1;
	TPopupMenu *pop_edit;
	TMenuItem *Undo1;
	TSaveDialog *dlg_save;
	TOpenPictureDialog *dlg_pic;
	TImage *img_;
	TFontDialog *dlg_font;
	TColorDialog *dlg_co;
	void __fastcall FormShow(TObject *Sender);
	void __fastcall img_titlecenterMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall img_titleleftMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall img_titlerightMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall img_titlecenterDblClick(TObject *Sender);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall bg_menuClick(TObject *Sender);
	void __fastcall s_backgMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall FormCanResize(TObject *Sender, int &NewWidth, int &NewHeight,
          bool &Resize);
	void __fastcall p_attributeResize(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall vle_attributeKeyPress(TObject *Sender, char &Key);
	void __fastcall p_rcMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
	void __fastcall p_rcMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall p_rcMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall p_ctMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall BitBtn1Click(TObject *Sender);
	void __fastcall BitBtn2Click(TObject *Sender);
	void __fastcall Button2Click(TObject *Sender);
	void __fastcall page_winResize(TObject *Sender);
	void __fastcall p_cbMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
	void __fastcall p_ctMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
	void __fastcall p_lbMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
	void __fastcall p_lcMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
	void __fastcall p_ltMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
	void __fastcall p_rbMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
	void __fastcall p_rtMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
	void __fastcall p_cbMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall p_ctMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall p_lbMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall p_lcMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall p_ltMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall p_rbMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall p_rtMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall p_cbMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall p_lbMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall p_lcMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall p_ltMouseDown(TObject *Sender, TMouseButton Button,
		  TShiftState Shift, int X, int Y);
	void __fastcall p_rbMouseDown(TObject *Sender, TMouseButton Button,
		  TShiftState Shift, int X, int Y);
	void __fastcall p_rtMouseDown(TObject *Sender, TMouseButton Button,
		  TShiftState Shift, int X, int Y);
	void __fastcall sp_rightMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall sp_leftMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall sp_bottomMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall sp_topMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall sp_closeMouseEnter(TObject *Sender);
	void __fastcall sp_closeMouseLeave(TObject *Sender);
	void __fastcall sp_closeMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall sp_minMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall sp_maxMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall bg_toolsButtonClicked(TObject *Sender, int Index);
	void __fastcall vle_attributeEditButtonClick(TObject *Sender);
	void __fastcall Button1Click(TObject *Sender);
	void __fastcall bg_menuItems0Click(TObject *Sender);
	void __fastcall bg_menuItems1Click(TObject *Sender);
	void __fastcall bg_menuItems2Click(TObject *Sender);
	void __fastcall bg_menuItems3Click(TObject *Sender);
	void __fastcall bg_menuItems4Click(TObject *Sender);
	void __fastcall me_saveClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
	__fastcall Tfrm_main(TComponent* Owner);
	int setEditingWindow();
	int clearEditingWindow();
	int addEditingWindow(HWND, DWORD);
	int select(HWND hwnd);

	int DrawMoveBoxs();
	int DrawMoveShadow(String index);
	int ShowMoveBoxs();
	int HideMoveBoxs();

	HWND MakeControl(HWND phwnd, String index, RECT rect);


	int setRect(String index);

	void __fastcall psResize(TObject *Sender);

	int IDE_addObj(String, HWND);

	int IDE_eidtToMap();

	RECT createRect;
	HWND hwnd_select;
	RECT rect_select;

	list<HWND> m_wins;

	//map<HWND, map<string, string>*> map_obj;
	map<HWND, void *> map_obj;
	map<String, HWND> map_nameToHandle;
	map<HWND, void *> map_funaddr;

	map<HWND, void *> map_hwndToEvent;

	map<String, String> map_kindOfAtt;
};
//---------------------------------------------------------------------------
extern PACKAGE Tfrm_main *frm_main;
//---------------------------------------------------------------------------
#endif
